diff --git a/rathaxes/samples/e1000/ethernet.blt b/rathaxes/samples/e1000/ethernet.blt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/ethernet.blt
+++ b/rathaxes/samples/e1000/ethernet.blt
@@ -1,4 +1,4 @@
-with Ethernet, PCI, LKM, Log, Builtin
+with Ethernet, Socket, PCI, LKM, Log, Builtin
 {
     template type   Ethernet::ProtocolId()
     {
@@ -61,7 +61,7 @@
 
         method  init(Builtin::symbol dev)
         {
-            ${self} = (${Ethernet::AbstractDevice} *)${dev};
+            ${self} = (${Ethernet::AbstractDevice.ref})${dev};
         }
 
         map
@@ -104,9 +104,12 @@
         {
             static int rtx_ethernet_alloc_rx_skbuff(${Ethernet::Device.ref} self, ${Socket::SKBuff.ref} sk_buff, ${Builtin::number} size)
             {
-                ${Socket::AbstractSKBuff} k_sk_buff = netdev_alloc_skb(${local.self.net_device.k_net_dev}, ${local.size});
-                if (${local.k_sk_buff) {
-                    ${local.sk_buff.init(local.k_sk_buff, local.size)};
+                ${Socket::AbstractSKBuff.ref} k_skb = netdev_alloc_skb(${local.self.net_device.k_net_dev}, ${local.size});
+                if (${local.k_skb}) {
+                    // XXX meh, can't use the init method since we get a copy
+                    // of the pointer, so we have to do this which is
+                    // inconsistent with the rest of code:
+                    sk_buff->skbuff = k_skb;
                     return 0;
                 }
                 return 1;
@@ -148,7 +151,7 @@
         }
     }
 
-    template sequence   Ethernet::open(Ethernet::Device dev)
+    template sequence   Ethernet::open()
     {
         chunk   LKM::includes()
         {
@@ -164,60 +167,68 @@
         {
             static int  rtx_ethernet_open(struct net_device *dev)
             {
-                /*
-                 * XXX The casts are here because the compiler doesn't resolve
-                 * "enclosed" type (e.g: local.var.enclosed) correctly.
-                 */
                 ${Ethernet::AbstractDevice.ref} rtx_net_dev;
                 { /* XXX: I end up with a placeholder if I don't open a scope */
                     ${local.rtx_net_dev.init(local.dev)};
                 }
                 ${Ethernet::Device.ref} rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
 
-                int error;
-                {
-                    ${Log::info("installing the interrupt handler")};
-                }
-                error = request_irq(${local.rtx_ether_ctx.irq},
-                                    rtx_ethernet_interrupt_handler,
-                                    IRQF_SHARED,
-                                    ${config.name},
-                                    dev);
-                if (error)
-                {
+                ${pointcut Ethernet::adapter_setup_rx_tx(local.rtx_ether_ctx)};
+
+                ${Log::info("Installing the interrupt handler")};
+                int error = request_irq(
+                    ${local.rtx_ether_ctx.irq},
+                    rtx_ethernet_interrupt_handler,
+                    IRQF_SHARED,
+                    ${config.name},
+                    dev
+                );
+                if (error) {
                     ${Log::info("Cannot register the interrupt handler")};
                     return error;
                 }
-                ${pointcut Ethernet::adapter_setup(local.rtx_ether_ctx)};
-                ${pointcut Ethernet::adapter_init_rx(local.rtx_ether_ctx)};
-                ${pointcut Ethernet::adapter_init_tx(local.rtx_ether_ctx)};
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
+
+                ${pointcut Ethernet::adapter_enable_interrupts(local.rtx_ether_ctx)};
 
                 return 0;
             }
         }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
     }
 
-    template sequence   Ethernet::send(Ethernet::Device dev, Socket::AbstractSKBuff skb)
+    template sequence   Ethernet::send()
     {
         chunk LKM::prototypes()
         {
-            static int  rtx_ethernet_xmit(struct sk_buff* skb, struct net_device *dev);
+            static int  rtx_ethernet_xmit(struct sk_buff *skb, struct net_device *dev);
         }
 
         chunk LKM::code()
         {
-            static int  rtx_ethernet_xmit(struct sk_buff* kernel_skb, struct net_device *net_dev)
+            static int  rtx_ethernet_xmit(struct sk_buff *k_skb, struct net_device *net_dev)
             {
                 ${Ethernet::Device.ref} rtx_ether_ctx = netdev_priv(net_dev);
-                ${Socket::AbstractSKBuff.ref} rtx_skb = (${Socket::AbstractSKBuff.ref}) kernel_skb;
+                ${Socket::SKBuff.ref} rtx_skb;
 
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx, local.rtx_skb)};
+                ${cast local.k_skb as Socket::AbstractSKBuff.ref};
+                ${local.rtx_skb.init(local.k_skb)};
+
+                ${Log::info("we have one packet to transmit!")};
+                ${pointcut Ethernet::adapter_xmit(local.rtx_ether_ctx, local.rtx_skb)};
             }
         }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
     }
 
-    template sequence   Ethernet::close(Ethernet::Device dev)
+    template sequence   Ethernet::close()
     {
         chunk LKM::prototypes()
         {
@@ -226,31 +237,37 @@
 
         chunk LKM::code()
         {
-            static int  rtx_ethernet_close(struct net_device *dev)
+            static int  rtx_ethernet_close(struct net_device *net_dev)
             {
-                ${Ethernet::AbstractDevice.ref} rtx_net_dev;
-                { /* XXX: I end up with a placeholder if I don't open a scope */
-                    ${local.rtx_net_dev.init(local.dev)};
-                }
+                ${cast local.net_dev as Ethernet::AbstractDevice.ref};
+                ${Ethernet::Device.ref} rtx_ether_ctx = ${local.net_dev.rtx_ether_ctx};
 
-                ${Ethernet::Device.ref} rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
+                ${pointcut Ethernet::adapter_disable_rx(local.rtx_ether_ctx)};
 
-                /* TODO: change this pointcut into a pointcut/adapter/callback: */
-                {
-                    ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
-                }
+                netif_tx_disable(net_dev);
+                ${pointcut Ethernet::adapter_disable_tx(local.rtx_ether_ctx)};
 
+                ${pointcut Ethernet::adapter_disable_interrupts(local.rtx_ether_ctx)};
                 free_irq(${local.rtx_ether_ctx.irq}, dev);
-                {
-                    ${Log::info("interrupt handler free'ed")};
-                }
+                ${Log::info("interrupt handler free'ed")};
+
+                // TODO/XXX: There is definitely more stuff to do around here
+                // (e.g: clean the rings, flush some stuff...)
+
+                ${pointcut Ethernet::adapter_reset(local.rtx_ether_ctx)};
+                ${pointcut Ethernet::adapter_free_rx_tx(local.rtx_ether_ctx)};
 
                 return 0;
             }
         }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
     }
 
-    template sequence   Ethernet::interrupt_handler(Ethernet::Device dev)
+    template sequence   Ethernet::interrupt_handler()
     {
         /*
          * We can't use the irqreturn_t type here because CNornm doesn't know
@@ -269,11 +286,16 @@
                 ${Ethernet::Device.ref} rtx_ether_ctx;
                 rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
 
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
+                ${pointcut Ethernet::adapter_handle_interrupt(local.rtx_ether_ctx)};
 
                 return IRQ_NONE;
             }
         }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
     }
 
     template sequence   Ethernet::init()
@@ -342,12 +364,8 @@
              * XXX: the asssignments/casts are here to circumvent
              * typing issues in the compiler (see previous XXX).
              */
-            int bars = ${rtx_pci_dev.bars};
             unsigned char /* __iomem */ *ioaddr = ${rtx_pci_dev.ioaddr};
-            ${cast local.bars as Builtin::number};
-            ${pointcut Ethernet::adapter_init_context(local.rtx_ether_ctx,
-                                                      local.bars,
-                                                      local.ioaddr)};
+            ${pointcut Ethernet::adapter_init_context(local.rtx_ether_ctx, local.ioaddr)};
             ${pointcut Ethernet::adapter_reset(local.rtx_ether_ctx)};
             ${pointcut Ethernet::adapter_load_mac_address(local.rtx_ether_ctx)};
             memcpy(${local.rtx_ether_ctx.perm_addr},
@@ -355,7 +373,7 @@
                    ${local.rtx_net_dev.k_net_dev}->addr_len);
         }
 
-        /* This chunk should be removed (see #26) */
+        /* XXX This chunk should be removed (see #26) */
         chunk   ::CALL()
         {
         }
@@ -377,7 +395,7 @@
             free_netdev(${local.rtx_net_dev.k_net_dev});
         }
 
-        /* This chunk should be removed (see #26) */
+        /* XXX This chunk should be removed (see #26) */
         chunk ::CALL()
         {
         }
diff --git a/rathaxes/samples/e1000/ethernet.rti b/rathaxes/samples/e1000/ethernet.rti
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/ethernet.rti
+++ b/rathaxes/samples/e1000/ethernet.rti
@@ -2,16 +2,16 @@
 {
     required variable   Builtin::string ifname;
 
-     provided type   ProtocolId
-     {
-         chunk       LKM::prototypes();
-         chunk       LKM::data();
-         chunk       LKM::code();
-         decl        data_types();
+    provided type   ProtocolId
+    {
+        chunk       LKM::prototypes();
+        chunk       LKM::data();
+        chunk       LKM::code();
+        decl        data_types();
 
-         attribute  Builtin::number.scalar id;
-         attribute  Builtin::string.scalar str;
-     }
+        attribute  Builtin::number.scalar id;
+        attribute  Builtin::string.scalar str;
+    }
 
     provided type   AbstractDevice
     {
@@ -28,72 +28,88 @@
 
     provided type   Device
     {
+        decl        data_types();
+
         chunk       LKM::includes();
-        decl        data_types();
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+
         pointcut    Ethernet::HardwareContext();
 
         method      init(Ethernet::AbstractDevice, PCI::AbstractDevice);
-        /*
-         * Alloc (the AbstractSKBuff inside) the given SKBuff and initialize
-         * the SKBuff, return 1 if the allocation failed, 0 on success.
-         */
+
+        // Alloc (the AbstractSKBuff inside) the given SKBuff and initialize
+        // the SKBuff, return 1 if the allocation failed, 0 on success:
         method      alloc_rx_skbuff(Socket::SKBuff, Builtin::number);
 
         attribute   Device::AbstractDevice.ref      device;
         attribute   PCI::AbstractDevice.ref         pci_device;
         attribute   Ethernet::AbstractDevice.ref    net_device;
-        /*
-         * I'd like to use better names here, but I'd like to understand the
-         * difference between the two first:
-         */
+
+        // I'd like to use better names here, but I'd like to understand the
+        // difference between the two first:
         attribute   Builtin::symbol.ref     perm_addr;
         attribute   Builtin::symbol.ref     dev_addr;
         attribute   Builtin::symbol.scalar  irq;
     }
 
-    required sequence   open(Ethernet::Device)
+    provided sequence       open()
     {
-        provided chunk  LKM::includes();
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
+        provided chunk      LKM::includes();
+        provided chunk      LKM::prototypes();
+        provided chunk      LKM::code();
 
-        /*
-         * For e1000, this part is documented in the Intel Gigabit Ethernet
-         * Controller Software Developper manual. (You can find it in the
-         * doc/hardware directory).
-         */
-        provided pointcut   Ethernet::adapter_setup(Ethernet::Device);
-        provided pointcut   Ethernet::adapter_init_rx(Ethernet::Device);
-        provided pointcut   Ethernet::adapter_init_tx(Ethernet::Device);
+        // Prepare the device and the resources for rx/tx:
+        provided pointcut   Ethernet::adapter_setup_rx_tx(Ethernet::Device);
+
+        // Enable interrupts:
+        provided pointcut   Ethernet::adapter_enable_interrupts(Ethernet::Device);
     }
 
-    required sequence   send(Ethernet::Device, Socket::AbstractSKBuff)
+    provided sequence       send()
     {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
+        provided chunk      LKM::prototypes();
+        provided chunk      LKM::code();
+
+        // Put a packet on the tx ring and signal the device:
+        provided pointcut   Ethernet::adapter_xmit(Ethernet::Device, Socket::SKBuff);
     }
 
-    required sequence   close(Ethernet::Device)
+    provided sequence   close()
     {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
+        provided chunk      LKM::prototypes();
+        provided chunk      LKM::code();
+
+        provided pointcut   Ethernet::adapter_disable_rx(Ethernet::Device);
+        provided pointcut   Ethernet::adapter_disable_tx(Ethernet::Device);
+        provided pointcut   Ethernet::adapter_disable_interrupts(Ethernet::Device);
+
+        // Clean and free all resources on the rx/tx rings:
+        provided pointcut   Ethernet::adapter_free_rx_tx(Ethernet::Device);
     }
 
-    required sequence   interrupt_handler(Ethernet::Device)
+    provided sequence       interrupt_handler()
     {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
+        provided chunk      LKM::prototypes();
+        provided chunk      LKM::code();
+
+        // Interrupt handler:
+        provided pointcut   Ethernet::adapter_handle_interrupt(Ethernet::Device);
     }
 
-    provided sequence   init()
+    provided sequence       init()
     {
-        provided chunk  LKM::data();
-        provided chunk  PCI::pci_probe_hook(PCI::Device);
+        provided chunk      LKM::data();
+        provided chunk      PCI::pci_probe_hook(PCI::Device);
 
-        provided pointcut   Ethernet::adapter_init_context(Ethernet::Device,
-                                                           Builtin::number,
-                                                           Builtin::symbol);
+        // Init the hardware context structure, doesn't allocate anything:
+        provided pointcut   Ethernet::adapter_init_context(Ethernet::Device, Builtin::symbol);
+
+        // Reset the adapter:
         provided pointcut   Ethernet::adapter_reset(Ethernet::Device);
+
+        // Load the MAC address from the EEPROM and save it into the
+        // dev_addr field/attribute of Ethernet::Device:
         provided pointcut   Ethernet::adapter_load_mac_address(Ethernet::Device);
     }
 
diff --git a/rathaxes/samples/e1000/lkm.rtx b/rathaxes/samples/e1000/lkm.rtx
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/lkm.rtx
+++ b/rathaxes/samples/e1000/lkm.rtx
@@ -1,40 +1,5 @@
 device LKM use LKM, PCI, Ethernet, Log, Socket
 {
-    Ethernet::open(Ethernet::Device dev)
-    {
-        Log::info("opening the device");
-
-        e1000::activate_device_interruption(dev);
-        Log::info("interruption enabled");
-
-        e1000::print_status(dev);
-    }
-
-    Ethernet::close(Ethernet::Device dev)
-    {
-        Log::info("closing the device");
-
-        /*
-         * Note: some calls to release resources must be done when IRQs are
-         * enabled (dma_free_coherent() for example). So we have to cleanup our
-         * stuff before free_interrupt_handler().
-         */
-        e1000::free_rx_tx(dev);
-        Log::info("free'ed up rx/tx resources");
-    }
-
-    Ethernet::interrupt_handler(Ethernet::Device dev)
-    {
-        Log::info("got an interruption");
-        e1000::handle_interrupt(dev);
-    }
-
-    Ethernet::send(Ethernet::Device dev, Socket::AbstractSKBuff skb)
-    {
-        Log::info("we have one packet to transmit!");
-        e1000::xmit(dev, skb);
-    }
-
     LKM::init()
     {
         Log::info("loading module");
@@ -50,7 +15,7 @@
 {
     LKM::name = "rtx_e1k";
     LKM::author = "Rathaxes";
-    LKM::description = "Hello World Loadable Kernel Module (LKM)";
+    LKM::description = "Rathaxes Intel PCI Gigabit NIC sample driver";
     LKM::license = "GPL";
 
     /*
diff --git a/rathaxes/samples/e1000/e1000.blt b/rathaxes/samples/e1000/old_e1000.blt
old mode 100755
new mode 100644
copy from rathaxes/samples/e1000/e1000.blt
copy to rathaxes/samples/e1000/old_e1000.blt
--- a/rathaxes/samples/e1000/e1000.blt
+++ b/rathaxes/samples/e1000/old_e1000.blt
@@ -170,14 +170,15 @@
                 for (i = 0; i != ${config.rx_ring_size}; ++i)
                 {
                     ${Socket::SKBuff.ref} skbuff = &hw_ctx->rx_ring.skbuffs[i];
-                    // XXX #46: ${rtx_ether_ctx.init_rx_skbuff(local.skbuff, config.rx_buffer_len)};
-                    if (rtx_ethernet_init_rx_skbuff(${local.skbuff}, ${config.rx_buffer_len}))
+                    // XXX #46: ${rtx_ether_ctx.alloc_rx_skbuff(local.skbuff, config.rx_buffer_len)};
+                    if (rtx_ethernet_alloc_rx_skbuff(${local.skbuff}, ${config.rx_buffer_len}))
                     {
                         ${Log::info("adapter_init_rx: cannot allocate a skbuff for the rx ring")};
                         goto err_skbuffs_alloc;
                     }
-                    // XXX #46: ${local.skbuff.map_from(rtx_ether_ctx.device)};
-                    if (rtx_socket_skbuff_map(${local.skbuff}, ${rtx_ether_ctx.device}, RTX_DMA_FROM_DEVICE))
+                    /* XXX: recuperer le dma handle et le placer correctement dans le descripteur. */
+                    ${DMA::map(local.rtx_ether_ctx.device, local.skbuff.data, local.skbuff.len, RTX_DMA_FROM_DEVICE)}
+                    if (${DMA::map(local.rtx_ether_ctx.device, local.skbuff.data, local.skbuff.len, RTX_DMA_FROM_DEVICE)})
                     {
                         ${Log::info("adapter_init_rx: cannot dma-map a skbuff for the rx ring")};
                         goto err_skbuffs_map;
diff --git a/rathaxes/samples/e1000/socket.blt b/rathaxes/samples/e1000/socket.blt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/socket.blt
+++ b/rathaxes/samples/e1000/socket.blt
@@ -22,16 +22,12 @@
     {
         decl  data_types()
         {
-            ${Socket::AbstractSKBuff.ref}       skbuff;
-            ${DMA::AbstractDMAHandle.scalar}    dma_handle;
-            unsigned int                        size;
+            ${Socket::AbstractSKBuff.ref}   skbuff;
         }
 
         chunk   LKM::prototypes()
         {
             static void rtx_socket_skbuff_dump_infos(${Socket::SKBuff.ref});
-            static int  rtx_socket_skbuff_map(${Socket::SKBuff.ref}, ${Device::AbstractDevice.ref}, ${DMA::DMADirection.scalar});
-            static void rtx_socket_skbuff_unmap_and_free(${Socket::SKBuff.ref}, ${Device::AbstractDevice.ref}, ${DMA::DMADirection.scalar});
         }
 
         chunk   LKM::code()
@@ -52,98 +48,29 @@
                  * arguments yet.
                  */
                 pr_info(
-                        "\t protocol = %#-5x (%s) ip_summed = %d (%s)\n"
-                        "\t      len = %-5u data_len = %-5u head_len = %-5u\n"
-                        "\t nr_frags = %u\n"
-                        "\t gso_size = %-5u gso_segs = %-5u gso_type = %-5u",
-                        /* XXX: can't use ${local.ethernet_proto.id} here (issue #52): */
-                        ethernet_proto.id, ${local.ethernet_proto.str},
-                        ${local.self.sk_buff.k_sk_buff}->ip_summed, ip_summed_values[${local.self.sk_buff.k_sk_buff}->ip_summed],
-                        ${local.self.sk_buff.k_sk_buff}->len, ${local.self.sk_buff.k_sk_buff}->data_len, skb_headlen(${local.self.sk_buff.k_sk_buff}),
-                        shinfo->nr_frags, shinfo->gso_size, shinfo->gso_segs, shinfo->gso_type
+                    "\t protocol = %#-5x (%s) ip_summed = %d (%s)\n"
+                    "\t      len = %-5u data_len = %-5u head_len = %-5u\n"
+                    "\t nr_frags = %u\n"
+                    "\t gso_size = %-5u gso_segs = %-5u gso_type = %-5u",
+                    /* XXX: can't use ${local.ethernet_proto.id} here (issue #52): */
+                    ethernet_proto.id, ${local.ethernet_proto.str},
+                    ${local.self.sk_buff.k_sk_buff}->ip_summed, ip_summed_values[${local.self.sk_buff.k_sk_buff}->ip_summed],
+                    ${local.self.sk_buff.k_sk_buff}->len, ${local.self.sk_buff.k_sk_buff}->data_len, skb_headlen(${local.self.sk_buff.k_sk_buff}),
+                    shinfo->nr_frags, shinfo->gso_size, shinfo->gso_segs, shinfo->gso_type
                 );
             }
-
-            static int rtx_socket_skbuff_map(${Socket::SKBuff.ref} self,
-                                             ${Device::AbstractDevice.ref} dev,
-                                             ${DMA::DMADirection.scalar} direction)
-            {
-                WARN_ON(!${local.self.sk_buff});
-                WARN_ON(${local.self.dma_handle});
-                /*
-                 * TODO: we don't support skbuffs with paged data yet (see also
-                 * http://vger.kernel.org/~davem/skb_data.html).
-                 */
-                WARN_ON(skb_is_nonlinear(${local.self.sk_buff.k_sk_buff}));
-
-                unsigned int len = ${local.self.size};
-                ${cast local.len as Builtin::number};
-                ${local.self.dma_handle} = ${DMA::map(local.dev, local.self.sk_buff.k_sk_buff, local.len, local.direction)};
-                int err = ${DMA::mapping_error(local.dev, local.self.dma_handle)};
-                if (err)
-                {
-                    ${local.self.dma_handle} = 0;
-                    return err;
-                }
-                return 0;
-            }
-
-            static void rtx_socket_skbuff_unmap_and_free(${Socket::SKBuff.ref} self,
-                                                         ${Device::AbstractDevice.ref} dev,
-                                                         ${DMA::DMADirection} direction)
-            {
-                WARN_ON(!${local.self.sk_buff});
-                WARN_ON(skb_is_nonlinear(${local.self.sk_buff.k_sk_buff});
-
-                if (${local.self.dma_handle})
-                {
-                    unsigned int len = ${local.self.size};
-                    ${cast local.len as Builtin::number};
-                    ${DMA::unmap(local.dev, local.self.dma_handle, local.len, local.direction)};
-                    ${local.self.dma_handle} = 0;
-                }
-                dev_kfree_skb_any(${local.self.sk_buff.k_sk_buff});
-                ${local.self.sk_buff} = NULL;
-            }
         }
 
-        /*
-         * XXX: the rathaxes argument kernel_skb is not actually bound to the
-         * correct C variable from Ethernet::send() (so I named it as the C
-         * variable I needed)
-         */
-        method  init(Socket::AbstractSKBuff kernel_skb, Builtin::number size)
+        method init(Socket::AbstractSKBuff k_skb)
         {
-            ${self.sk_buff} = ${kernel_skb};
-            ${self.size} = ${size};
-            ${self.dma_handle} = 0;
+            ${self} = (${Socket::SKBuff.ref})(${k_skb});
         }
 
-        method  dump_infos()
+        method dump_infos()
         {
             rtx_socket_skbuff_dump_infos(${self});
         }
 
-        method   map_to(Device::AbstractDevice dev)
-        {
-            rtx_socket_skbuff_map(${self}, ${dev}, RTX_DMA_TO_DEVICE);
-        }
-
-        method   map_from(Device::AbstractDevice dev)
-        {
-            rtx_socket_skbuff_map(${self}, ${dev}, RTX_DMA_FROM_DEVICE);
-        }
-
-        method   unmap_to_and_free(Device::AbstractDevice dev)
-        {
-            rtx_socket_skbuff_unmap_and_free(${self}, ${dev}, RTX_DMA_TO_DEVICE);
-        }
-
-        method   unmap_from_and_free(Device::AbstractDevice dev)
-        {
-            rtx_socket_skbuff_unmap_and_free(${self}, ${dev}, RTX_DMA_FROM_DEVICE);
-        }
-
         map
         {
             // Some work may have to be done here in order to access to some
@@ -151,13 +78,9 @@
             // management can be abstracted from the user. But this is at least
             // useful for internal use:
             sk_buff: (${self})->skbuff;
-            // XXX: We need to cast here so we can do things like
-            // var.dma_handle = 0; but the type shouldn't be hardcoded (at the
-            // same time ${DMA:AbstractDMAHandle} couldn't be used because that
-            // would yield to a struct type which you can't assign directly;
-            // but maybe doing the ->data in that case would be acceptable).
-            dma_handle: (*((dma_addr_t *)&(${self})->dma_handle));
-            size: (${self})->size;
+
+            data: ((struct sk_buff *)((${self})->sk_buff))->data;
+            len: ((struct sk_buff *)((${self})->sk_buff))->len;
         }
     }
 }
diff --git a/rathaxes/samples/e1000/socket.rti b/rathaxes/samples/e1000/socket.rti
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/socket.rti
+++ b/rathaxes/samples/e1000/socket.rti
@@ -12,20 +12,14 @@
     {
         chunk   LKM::prototypes();
         chunk   LKM::code();
+
         decl    data_types();
-        method  init(Socket::AbstractSKBuff, Builtin::number);
+
+        method  init(Socket::AbstractSKBuff);
         method  dump_infos();
-        /*
-         * map_to and map_from return a non-zero value on failure (which
-         * doesn't correspond to an errno value):
-         */
-        method  map_to(Device::AbstractDevice);
-        method  map_from(Device::AbstractDevice);
-        method  unmap_to_and_free(Device::AbstractDevice);
-        method  unmap_from_and_free(Device::AbstractDevice);
 
-        attribute   Socket::AbstractSKBuff.ref      sk_buff;
-        attribute   DMA::AbstractDMAHandle.scalar   dma_handle;
-        attribute   Builtin::number.scalar          size;
+        attribute   Socket::AbstractSKBuff.ref  sk_buff;
+        attribute   Builtin::symbol.ref         data;
+        attribute   Builtin::number.scalar      len;
     }
 }
